// LiteLoader-AIDS automatic generated
/// <reference path="e:\llse/dts/llaids/src/index.d.ts"/> 

if (!File.exists("./plugins/Planet/PVip/module/vip_buff.js"))
    colorLog("red", "这是PVip插件的扩展模块,无法直接在运行在LiteLoaderBDS和LeviLamina中,请按照教程按照到PVip的模块中")
else {
    const ad_refresh = 1000;//广告刷新时间 1000 = 1秒
    const ad_data = new JsonConfigFile('./plugins/Planet/PVip/module/data/addata.json');// 广告的数据存储路径 
    const AD = {
        get(name) {
            ad_data.reload();
            if (name)
                return ad_data.get(name);
            else
                return JSON.parse(ad_data.read());
        },
        add(name, text, time) {
            ad_data.reload();
            return ad_data.set(name, { text: text, time: Number(time), add_time: system.getTimeStr() });
        },
        del(name) {
            ad_data.reload();
            return ad_data.delete(name);
        }
    };
    setInterval(() => {
        const all_ad = AD.get();
        const ad_name = Object.keys(all_ad);
        ad_name.forEach((name) => {
            let interval = Math.ceil((new Date(system.getTimeStr()).getTime() - new Date(all_ad[name].add_time).getTime()) / (1000 * 60 * 60 * 24))
            if (interval > 1) AD.del(name);
            if (all_ad[name].text) {
                mc.broadcast(`[会员广告] ${all_ad[name].text}    ---来自${name}`);
            };
        });
    }, ad_refresh);// 广告循环刷新
    module.exports = {
        name: "会员广告扩展模块",
        version: "0.0.1",
        author: "苏苏",
        type: "vip_form",
        text: "会员广告",
        path: "",
        /**
         * 被调用的默认函数
         * @param {Player} player 玩家对象
         * @param {Objective} additional_data 附加数据（目前传递为玩家的VIP数据）
         * @param {Function} functions 上级表单（用于返回注册表单）
         */
        main(player, additional_data, functions, err, ad_text, ad_time) {
            if (AD.get(player.realName)) {
                let fm = mc.newSimpleForm();
                fm.setTitle("会员广告");
                fm.setContent("应插件作者的要求，每个会员玩家只能发布一则限时广告\n\n\n\n是否删除历史广告?");
                fm.addButton("确定");
                player.sendForm(fm, (player, id) => {
                    if (id == null) {
                        functions(player, additional_data.file, additional_data.data);
                    } else {
                        AD.del(player.realName);
                        this.main(player, additional_data, functions);
                    };
                });
            } else {
                let fm = mc.newCustomForm();
                fm.setTitle("会员广告");
                fm.addInput("广告内容", "例如: 这是一个会员广告", ad_text || "");
                fm.addInput("广告有效时间（最多3天,管理员可设置为7天）", "例如:3", ad_time || "");
                if (err) fm.addLabel(err);
                player.sendForm(fm, (player, id) => {
                    if (id == null) {
                        functions(player, additional_data.file, additional_data.data);
                    } else {
                        ad_text = id[0], ad_time = id[1];
                        if (ad_text == "")
                            ad_text = ["err", "§l§c请填写广告内容"];
                        if (ad_time == "") {
                            ad_time = ["err", "§l§c请填写广告有效时间"];
                        } else if (!isNaN(ad_time)) {
                            if (Number(ad_time) > 0 && Number(ad_time) < 8) {
                                if (!player.isOP() && Number(ad_time) > 3)
                                    ad_time = ["err", "§l§c你不是管理员无法添加超过3天"];
                            } else {
                                ad_time = ["err", "§l§c有效时间只能是1-3天,管理员可以设置1-7天"];
                            }
                        } else {
                            ad_time = ["err", "§l§c有效时间必须为数值"];
                        }
                        if (ad_text[0] == "err") {
                            this.main(player, additional_data, functions, ad_text[1], id[0], id[1]);
                        } else if (ad_time[0] == "err") {
                            this.main(player, additional_data, functions, ad_time[1], id[0], id[1]);
                        } else {
                            player.sendModalForm("添加广告", `广告内容:${ad_text}\n有效时间:${ad_time}天`, "确认添加", "返回修改",
                                (player, zid) => {
                                    if (zid) {
                                        AD.add(player.realName, ad_text, ad_time);
                                        mc.broadcast(`[会员广告] ${ad_text}    ---来自${player.realName}`);
                                        player.tell(`[会员广告] 添加成功`);
                                        functions(player, additional_data.file, additional_data.data);
                                    } else {
                                        main(player, additional_data, functions, null, id[0], id[1]);
                                    };
                                });
                        };
                    };
                });
            };
        }
    };
};